/* reAction.h - header file for Actions that are 'called' when executing the rules by 
 * the rule engine modules
 */
#ifndef RE_ACTION_H
#define RE_ACTION_H

#include "rodsUser.h"
#include "rods.h"
#include "rcGlobalExtern.h"
#include "reDefines.h"
#include "objInfo.h"
#include "regExpMatch.h"
#include "reSysDataObjOpr.h"
#include "msiHelper.h"
#include "reDataObjOpr.h"
#include "reNaraMetaData.h"
#include "reIn2p3SysRule.h"
#ifdef NETCDF_API
#include "reNetcdf.h"
#endif






typedef struct {
  char action[MAX_ACTION_SIZE];
  int numberOfStringArgs;
  funcPtr callAction;
} microsdef_t;

int print_hello(ruleExecInfo_t *c);
int print_hello_arg(msParam_t* xs, ruleExecInfo_t *rei );
int delayExec(msParam_t* condition, msParam_t* workflow, 
	      msParam_t* recoverWorkFlow, ruleExecInfo_t *rei);
int remoteExec(msParam_t* hostName, msParam_t* condition, msParam_t* workflow, 
	      msParam_t* recoverWorkFlow, ruleExecInfo_t *rei);
int msiSleep(msParam_t* sec, msParam_t* microsec, ruleExecInfo_t *rei);
int writeBytesBuf(msParam_t* where, msParam_t* inBuf, ruleExecInfo_t *rei);
int writePosInt(msParam_t* where, msParam_t* inInt, ruleExecInfo_t *rei);
int writeKeyValPairs(msParam_t *where, msParam_t *inKVPair, msParam_t *separator, ruleExecInfo_t *rei);
int msiGetDiffTime(msParam_t* inpParam1,  msParam_t* inpParam2, msParam_t* inpParam3, msParam_t* outParam, ruleExecInfo_t *rei);
int msiGetSystemTime(msParam_t* outParam,  msParam_t* inpParam, ruleExecInfo_t *rei);
int msiGetFormattedSystemTime( msParam_t* outParam, msParam_t* inpParam, msParam_t* inpFormatParam, ruleExecInfo_t *rei );
int msiHumanToSystemTime(msParam_t* inpParam, msParam_t* outParam, ruleExecInfo_t *rei);
int msiStrToBytesBuf(msParam_t* str_msp, msParam_t* buf_msp, ruleExecInfo_t *rei);
int msiBytesBufToStr(msParam_t* buf_msp, msParam_t* str_msp, ruleExecInfo_t *rei);

int msiApplyDCMetadataTemplate(msParam_t* inpParam, msParam_t* outParam, ruleExecInfo_t *rei);
int msiListEnabledMS(msParam_t *outKVPairs, ruleExecInfo_t *rei);
int msiServerBackup(msParam_t *options, msParam_t *keyValOut, ruleExecInfo_t *rei);

int  msiSetResource(msParam_t* xrescName, ruleExecInfo_t *rei);
int msiSendStdoutAsEmail(msParam_t* xtoAddr, msParam_t* xsubjectLine, ruleExecInfo_t *rei);
int msiPrintKeyValPair(msParam_t* where, msParam_t* inKVPair,  ruleExecInfo_t *rei);
int msiGetValByKey(msParam_t* inKVPair,  msParam_t* inKey, msParam_t* outVal,  ruleExecInfo_t *rei);
int msiAddKeyVal(msParam_t *inKeyValPair, msParam_t *key, msParam_t *value, ruleExecInfo_t *rei);
int msiApplyAllRules(msParam_t *actionParam, msParam_t* reiSaveFlagParam, 
	msParam_t* allRuleExecFlagParam, ruleExecInfo_t *rei);
int msiExecStrCondQuery(msParam_t* queryParam, msParam_t* genQueryOutParam, ruleExecInfo_t *rei);
int msiExecGenQuery(msParam_t* genQueryInParam, msParam_t* genQueryOutParam, ruleExecInfo_t *rei);
int msiMakeQuery(msParam_t* selectListParam, msParam_t* conditionsParam,
		 msParam_t* queryOutParam, ruleExecInfo_t *rei);
int msiMakeGenQuery(msParam_t* selectListStr, msParam_t* condStr, msParam_t* genQueryInpParam, ruleExecInfo_t *rei);
int msiGetMoreRows(msParam_t *genQueryInp_msp, msParam_t *genQueryOut_msp, msParam_t *continueInx, ruleExecInfo_t *rei);
int msiCloseGenQuery(msParam_t *genQueryInp_msp, msParam_t *genQueryOut_msp, ruleExecInfo_t *rei);
int msiAddSelectFieldToGenQuery(msParam_t *select, msParam_t *function, msParam_t *queryInput, ruleExecInfo_t *rei);
int msiAddConditionToGenQuery(msParam_t *attribute, msParam_t *coperator, msParam_t *value, msParam_t *queryInput, ruleExecInfo_t *rei);
int msiPrintGenQueryOutToBuffer(msParam_t *queryOut, msParam_t *format, msParam_t *buffer, ruleExecInfo_t *rei);

int msiVacuum(ruleExecInfo_t *rei);
int msiQuota(ruleExecInfo_t *rei);
int msiDeleteUnusedAVUs(ruleExecInfo_t *rei);
int msiGoodFailure(ruleExecInfo_t *rei);
int msiRegisterData(ruleExecInfo_t *rei);
int msiCheckPermission(msParam_t *perm, ruleExecInfo_t *rei);
int msiCheckAccess(msParam_t *inObjName, msParam_t * inOperation,
                   msParam_t * outResult, ruleExecInfo_t *rei);
int msiCheckOwner(ruleExecInfo_t *rei);
int msiCreateUser(ruleExecInfo_t *rei);
int msiCreateCollByAdmin(msParam_t *parColl, msParam_t *childName, ruleExecInfo_t *rei);
int msiCommit(ruleExecInfo_t *rei);
int msiDeleteCollByAdmin(msParam_t *parColl, msParam_t *childName, ruleExecInfo_t *rei);
int msiDeleteUser(ruleExecInfo_t *rei);
int msiAddUserToGroup(msParam_t *msParam, ruleExecInfo_t *rei);
int msiSendMail(msParam_t *toAddr, msParam_t *subjectLine, msParam_t *body, ruleExecInfo_t *rei);
int msiAdmChangeCoreIRB(msParam_t *newF, ruleExecInfo_t *rei);
//int msiAdmShowIRB(msParam_t *bufP, ruleExecInfo_t *rei);
int msiAdmShowDVM(msParam_t *bufP, ruleExecInfo_t *rei);
int msiAdmShowFNM(msParam_t *bufP, ruleExecInfo_t *rei);
int msiAdmAppendToTopOfCoreIRB(msParam_t *bufP, ruleExecInfo_t *rei);
int msiGetObjType(msParam_t *objNameP, msParam_t *objTypeP,
	      ruleExecInfo_t *rei);
int msiAssociateKeyValuePairsToObj(msParam_t *mDP, msParam_t* objP,  msParam_t* typP,
				   ruleExecInfo_t *rei);
int msiSetKeyValuePairsToObj(msParam_t *mDP, msParam_t* objP,  msParam_t* typP,
                                ruleExecInfo_t *rei);
int msiExtractTemplateMDFromBuf(msParam_t* sOP, msParam_t* tSP, 
			   msParam_t *mDP, ruleExecInfo_t *rei);
int msiReadMDTemplateIntoTagStruct(msParam_t* sOP, msParam_t* tSP, ruleExecInfo_t *rei);
int msiFreeBuffer(msParam_t* memP, ruleExecInfo_t *rei);
int msiGetIcatTime(msParam_t* timeOutParam,  msParam_t* typeInParam, ruleExecInfo_t *rei);

int msiGetTaggedValueFromString(msParam_t *inTagParag, msParam_t *inStrParam,
				msParam_t *outValueParam, ruleExecInfo_t *rei);
int recover_print_hello(ruleExecInfo_t *c);

int recover_msiCreateUser(ruleExecInfo_t *rei);
int recover_msiCreateCollByAdmin(msParam_t *parColl, msParam_t *childName, ruleExecInfo_t *rei);

int msiXmsgServerConnect(msParam_t* outConnParam, ruleExecInfo_t *rei);
int msiXmsgCreateStream(msParam_t* inConnParam, 
			msParam_t* inGgetXmsgTicketInpParam, 
			msParam_t* outXmsgTicketInfoParam, 
			ruleExecInfo_t *rei);
int msiCreateXmsgInp(msParam_t* inMsgNumber,
		  msParam_t* inMsgType,
		  msParam_t* inNumberOfReceivers,
		  msParam_t* inMsg,
		  msParam_t* inNumberOfDeliverySites,
		  msParam_t* inDeliveryAddressList,
		  msParam_t* inDeliveryPortList,
		  msParam_t* inMiscInfo,
		  msParam_t* inXmsgTicketInfoParam,
		  msParam_t* outSendXmsgInfoParam,
		ruleExecInfo_t *rei);
int msiSendXmsg(msParam_t* inConnParam, 
		msParam_t* inSendXmsgInpParam,
		ruleExecInfo_t *rei);
int msiRcvXmsg(msParam_t* inConnParam, 
	       msParam_t* inTicketNumber,
	       msParam_t* inMsgNumber,
	       msParam_t* outMsgType,
	       msParam_t* outMsg,
	       msParam_t* outSendUser,
	       ruleExecInfo_t *rei);
int msiXmsgServerDisConnect(msParam_t* inConnParam, ruleExecInfo_t *rei);
int msiString2KeyValPair(msParam_t *inBufferP, msParam_t* outKeyValPairP, ruleExecInfo_t *rei);
int msiStrArray2String(msParam_t* inSAParam, msParam_t* outStr, ruleExecInfo_t *rei);

int msiRdaToStdout(msParam_t *inpRdaName, msParam_t *inpSQL, 
	 msParam_t *inpParam1, msParam_t *inpParam2, 
	 msParam_t *inpParam3, msParam_t *inpParam4, 
	 ruleExecInfo_t *rei);
int msiRdaToDataObj(msParam_t *inpRdaName, msParam_t *inpSQL, 
	 msParam_t *inpParam1, msParam_t *inpParam2, 
	 msParam_t *inpParam3, msParam_t *inpParam4, 
	 msParam_t *inOutFd, ruleExecInfo_t *rei);
int msiRdaNoResults(msParam_t *inpRdaName, msParam_t *inpSQL, 
	 msParam_t *inpParam1, msParam_t *inpParam2, 
	 msParam_t *inpParam3, msParam_t *inpParam4, 
	 ruleExecInfo_t *rei);
int msiRdaCommit(ruleExecInfo_t *rei);
int msiAW1(msParam_t* mPIn, msParam_t* mPOut2, ruleExecInfo_t *rei);
int msiRdaRollback(ruleExecInfo_t *rei);
int msiRenameLocalZone(msParam_t *oldName, msParam_t *newName,
                       ruleExecInfo_t *rei);
int msiRenameCollection(msParam_t *oldName, msParam_t *newName,
                       ruleExecInfo_t *rei);
int msiAclPolicy(msParam_t *msParam, ruleExecInfo_t *rei);
int msiSetQuota(msParam_t *type, msParam_t *name, msParam_t *resource, 
				msParam_t *value, ruleExecInfo_t *rei);
int msiRemoveKeyValuePairsFromObj(msParam_t *metadataParam, 
                                  msParam_t* objParam,
                                  msParam_t* typeParam,
                                  ruleExecInfo_t *rei);

int msiDataObjPutWithOptions (msParam_t *inpParam1, 
                              msParam_t *inpParam2,
                              msParam_t *inpParam3,
                              msParam_t *inpOverwriteParam,
                              msParam_t *inpAllCopiesParam, 
                              msParam_t *outParam, 
                              ruleExecInfo_t *rei);

int
msiPrintGenQueryInp( msParam_t *where, msParam_t* genQueryInpParam, ruleExecInfo_t *rei);

int msiExecStrCondQueryWithOptionsNew(msParam_t* queryParam,
                                  msParam_t* zeroResultsIsOK,
                                  msParam_t* maxReturnedRowsParam,
                                  msParam_t* genQueryOutParam,
                                  ruleExecInfo_t *rei);
int msiExecStrCondQueryWithOptions(msParam_t* queryParam,
                                  msParam_t* zeroResultsIsOK,
                                  msParam_t* maxReturnedRowsParam,
                                  msParam_t* genQueryOutParam,
                                  ruleExecInfo_t *rei);

int msiAutoReplicateService(msParam_t *xColl,
                            msParam_t *xRecursive,
                            msParam_t *xRequireNumReplicas,
                            msParam_t *xRescGroup,
                            msParam_t *xEmailAccountToNotify,
                            ruleExecInfo_t *rei);

int msiDataObjAutoMove(msParam_t *inpParam1,
                       msParam_t *inpParam2,
                       msParam_t *inpParam3,
                       msParam_t *inpParam4,
                       msParam_t *inpParam5,
                       ruleExecInfo_t *rei);

int
msiGetContInxFromGenQueryOut(msParam_t* genQueryOutParam, msParam_t* continueInx, ruleExecInfo_t *rei);

int msiAdmReadDVMapsFromFileIntoStruct(msParam_t *inDvmFileNameParam, msParam_t *outCoreDVMapStruct, ruleExecInfo_t *rei);
int msiAdmInsertDVMapsFromStructIntoDB(msParam_t *inDvmBaseNameParam, msParam_t *inCoreDVMapStruct, ruleExecInfo_t *rei);
int msiGetDVMapsFromDBIntoStruct(msParam_t *inDvmBaseNameParam, msParam_t *inVersionParam, msParam_t *outCoreDVMapStruct, ruleExecInfo_t *rei);
int msiAdmWriteDVMapsFromStructIntoFile(msParam_t *inDvmFileNameParam, msParam_t *inCoreDVMapStruct, ruleExecInfo_t *rei);

int msiAdmReadFNMapsFromFileIntoStruct(msParam_t *inDvmFileNameParam, msParam_t *outCoreFNMapStruct, ruleExecInfo_t *rei);
int msiAdmInsertFNMapsFromStructIntoDB(msParam_t *inDvmBaseNameParam, msParam_t *inCoreFNMapStruct, ruleExecInfo_t *rei);
int msiGetFNMapsFromDBIntoStruct(msParam_t *inDvmBaseNameParam, msParam_t *inVersionParam, msParam_t *outCoreFNMapStruct, ruleExecInfo_t *rei);
int msiAdmWriteFNMapsFromStructIntoFile(msParam_t *inDvmFileNameParam, msParam_t *inCoreFNMapStruct, ruleExecInfo_t *rei);

int msiAdmReadMSrvcsFromFileIntoStruct(msParam_t *inMsrvcFileNameParam, msParam_t *outCoreMsrvcStruct, ruleExecInfo_t *rei);
int msiAdmInsertMSrvcsFromStructIntoDB(msParam_t *inMsrvcBaseNameParam, msParam_t *inCoreMsrvcStruct, ruleExecInfo_t *rei);
int msiGetMSrvcsFromDBIntoStruct(msParam_t *inStatus, msParam_t *outCoreMsrvcStruct, ruleExecInfo_t *rei);
int msiAdmWriteMSrvcsFromStructIntoFile(msParam_t *inMsrvcFileNameParam, msParam_t *inCoreMsrvcStruct, ruleExecInfo_t *rei);
int writeXMsg(msParam_t* inStreamId, msParam_t *inHdr, msParam_t *inMsg, ruleExecInfo_t *rei);
int readXMsg(msParam_t* inStreamId, msParam_t* inCondRead, 
	msParam_t *outMsgNum, msParam_t *outSeqNum,
      	msParam_t *outHdr, msParam_t *outMsg, 
	msParam_t *outUser, msParam_t *outAddr, ruleExecInfo_t *rei);
int msiSetReplComment(msParam_t *inpParam1, msParam_t *inpParam2, msParam_t *inpParam3, 
         msParam_t *inpParam4, ruleExecInfo_t *rei);
int
msiSetBulkPutPostProcPolicy (msParam_t *xflag, ruleExecInfo_t *rei);
int msiCutBufferInHalf(msParam_t* mPIn, ruleExecInfo_t *rei);
int msiDoSomething(msParam_t *inParam, msParam_t *outParam, ruleExecInfo_t *rei);
int msiDboExec(msParam_t *dbrName, msParam_t *dboName, msParam_t *dborName, 
               msParam_t *options, 
               msParam_t *inpParam1, msParam_t *inpParam2, 
               msParam_t *inpParam3, msParam_t *inpParam4, 
               msParam_t *inpParam5, msParam_t *inpParam6, 
               ruleExecInfo_t *rei);
int msiDbrCommit(msParam_t *dbrName, ruleExecInfo_t *rei);
int msiDbrRollback(msParam_t *dbrName, ruleExecInfo_t *rei);
int msiString2StrArray(msParam_t *inBufferP, msParam_t* outStrArrayP, ruleExecInfo_t *rei);

#ifdef USE_EIRODS

    #include "eirods_ms_plugin.h"

	namespace eirods {

		// =-=-=-=-=-=-=-
		// implementation of the microservice table class, which initializes the table during the ctor
		// inserting the statically compiled microservices during construction providing RAII behavior
		// NOTE:: this template class is the same as the ms_table typedef from eirods_ms_plugin.h
		template<>
		lookup_table< eirods::ms_table_entry* >::lookup_table() {
			table_[ "print_hello" ] = new eirods::ms_table_entry( "print_hello", 0, (funcPtr) print_hello );
			table_[ "print_hello_arg" ] = new eirods::ms_table_entry( "print_hello_arg", 1, (funcPtr) print_hello_arg );
			table_[ "msiVacuum" ] = new eirods::ms_table_entry( "msiVacuum", 0, (funcPtr) msiVacuum );
			table_[ "msiQuota" ] = new eirods::ms_table_entry( "msiQuota", 0, (funcPtr) msiQuota );
			table_[ "msiDeleteUnusedAVUs" ] = new eirods::ms_table_entry( "msiDeleteUnusedAVUs", 0, (funcPtr) msiDeleteUnusedAVUs );
			table_[ "msiGoodFailure" ] = new eirods::ms_table_entry( "msiGoodFailure", 0, (funcPtr) msiGoodFailure );
			table_[ "msiSetResource" ] = new eirods::ms_table_entry( "msiSetResource", 1,(funcPtr)  msiSetResource );
			table_[ "msiCheckPermission" ] = new eirods::ms_table_entry( "msiCheckPermission", 1,(funcPtr)  msiCheckPermission );
			table_[ "msiCheckAccess" ] = new eirods::ms_table_entry( "msiCheckAccess", 3,(funcPtr)  msiCheckAccess );
			table_[ "msiCheckOwner" ] = new eirods::ms_table_entry( "msiCheckOwner", 0, (funcPtr) msiCheckOwner );
			table_[ "msiCreateUser" ] = new eirods::ms_table_entry( "msiCreateUser", 0, (funcPtr) msiCreateUser );
			table_[ "msiCreateCollByAdmin" ] = new eirods::ms_table_entry( "msiCreateCollByAdmin",2, (funcPtr) msiCreateCollByAdmin );
			table_[ "msiSendMail" ] = new eirods::ms_table_entry( "msiSendMail",3, (funcPtr) msiSendMail );
			table_[ "recover_print_hello" ] = new eirods::ms_table_entry( "recover_print_hello", 0, (funcPtr) recover_print_hello );
			table_[ "msiCommit" ] = new eirods::ms_table_entry( "msiCommit", 0, (funcPtr) msiCommit );
			table_[ "msiRollback" ] = new eirods::ms_table_entry( "msiRollback", 0, (funcPtr) msiRollback );
			table_[ "msiDeleteCollByAdmin" ] = new eirods::ms_table_entry( "msiDeleteCollByAdmin",2, (funcPtr) msiDeleteCollByAdmin );
			table_[ "msiDeleteUser" ] = new eirods::ms_table_entry( "msiDeleteUser", 0, (funcPtr) msiDeleteUser );
			table_[ "msiAddUserToGroup" ] = new eirods::ms_table_entry( "msiAddUserToGroup", 1, (funcPtr) msiAddUserToGroup );
			table_[ "msiSetDefaultResc" ] = new eirods::ms_table_entry( "msiSetDefaultResc", 2, (funcPtr) msiSetDefaultResc );
			table_[ "msiSetRescSortScheme" ] = new eirods::ms_table_entry( "msiSetRescSortScheme", 1, (funcPtr) msiSetRescSortScheme );
			table_[ "msiSysReplDataObj" ] = new eirods::ms_table_entry( "msiSysReplDataObj", 2, (funcPtr) msiSysReplDataObj );
			table_[ "msiStageDataObj" ] = new eirods::ms_table_entry( "msiStageDataObj", 1, (funcPtr) msiStageDataObj );
			table_[ "msiSetDataObjPreferredResc" ] = new eirods::ms_table_entry( "msiSetDataObjPreferredResc", 1, (funcPtr) msiSetDataObjPreferredResc );
			table_[ "msiSetDataObjAvoidResc" ] = new eirods::ms_table_entry( "msiSetDataObjAvoidResc", 1, (funcPtr) msiSetDataObjAvoidResc );
			table_[ "msiSortDataObj" ] = new eirods::ms_table_entry( "msiSortDataObj", 1, (funcPtr) msiSortDataObj );
			table_[ "msiSysChksumDataObj" ] = new eirods::ms_table_entry( "msiSysChksumDataObj", 0, (funcPtr) msiSysChksumDataObj );
			table_[ "msiSetDataTypeFromExt" ] = new eirods::ms_table_entry( "msiSetDataTypeFromExt", 0, (funcPtr) msiSetDataTypeFromExt );
			table_[ "msiSetNoDirectRescInp" ] = new eirods::ms_table_entry( "msiSetNoDirectRescInp",1,(funcPtr) msiSetNoDirectRescInp );
			table_[ "msiSetNumThreads" ] = new eirods::ms_table_entry( "msiSetNumThreads", 3,(funcPtr) msiSetNumThreads );
			table_[ "msiDeleteDisallowed" ] = new eirods::ms_table_entry( "msiDeleteDisallowed",0,(funcPtr) msiDeleteDisallowed );
			table_[ "msiOprDisallowed" ] = new eirods::ms_table_entry( "msiOprDisallowed",0,(funcPtr) msiOprDisallowed );
			table_[ "msiDataObjCreate" ] = new eirods::ms_table_entry( "msiDataObjCreate",3,(funcPtr) msiDataObjCreate );
			table_[ "msiDataObjOpen" ] = new eirods::ms_table_entry( "msiDataObjOpen",2,(funcPtr) msiDataObjOpen );
			table_[ "msiDataObjClose" ] = new eirods::ms_table_entry( "msiDataObjClose",2,(funcPtr) msiDataObjClose );
			table_[ "msiDataObjLseek" ] = new eirods::ms_table_entry( "msiDataObjLseek",4,(funcPtr) msiDataObjLseek );
			table_[ "msiDataObjRead" ] = new eirods::ms_table_entry( "msiDataObjRead",3,(funcPtr) msiDataObjRead );
			table_[ "msiDataObjWrite" ] = new eirods::ms_table_entry( "msiDataObjWrite",3,(funcPtr) msiDataObjWrite );
			table_[ "msiDataObjUnlink" ] = new eirods::ms_table_entry( "msiDataObjUnlink",2,(funcPtr) msiDataObjUnlink );
			table_[ "msiDataObjRepl" ] = new eirods::ms_table_entry( "msiDataObjRepl",3,(funcPtr) msiDataObjRepl );
			table_[ "msiDataObjCopy" ] = new eirods::ms_table_entry( "msiDataObjCopy",4,(funcPtr) msiDataObjCopy );
			table_[ "msiExtractNaraMetadata" ] = new eirods::ms_table_entry( "msiExtractNaraMetadata",0,(funcPtr) msiExtractNaraMetadata );
			table_[ "msiSetMultiReplPerResc" ] = new eirods::ms_table_entry( "msiSetMultiReplPerResc",0,(funcPtr) msiSetMultiReplPerResc );
			table_[ "msiAdmChangeCoreIRB" ] = new eirods::ms_table_entry( "msiAdmChangeCoreIRB",1,(funcPtr) msiAdmChangeCoreIRB );
			//table_[ "msiAdmShowIRB" ] = new eirods::ms_table_entry( "msiAdmShowIRB",1,(funcPtr) msiAdmShowIRB );
			table_[ "msiAdmShowDVM" ] = new eirods::ms_table_entry( "msiAdmShowDVM",1,(funcPtr) msiAdmShowDVM );
			table_[ "msiAdmShowFNM" ] = new eirods::ms_table_entry( "msiAdmShowFNM",1,(funcPtr) msiAdmShowFNM );
			table_[ "msiAdmAppendToTopOfCoreIRB" ] = new eirods::ms_table_entry( "msiAdmAppendToTopOfCoreIRB",1,(funcPtr) msiAdmAppendToTopOfCoreIRB );
			table_[ "msiGetObjType" ] = new eirods::ms_table_entry( "msiGetObjType",2,(funcPtr) msiGetObjType );
			table_[ "msiAssociateKeyValuePairsToObj" ] = new eirods::ms_table_entry( "msiAssociateKeyValuePairsToObj",3,(funcPtr) msiAssociateKeyValuePairsToObj );
			table_[ "msiSetKeyValuePairsToObj" ] = new eirods::ms_table_entry( "msiSetKeyValuePairsToObj",3,(funcPtr) msiSetKeyValuePairsToObj );
			table_[ "msiExtractTemplateMDFromBuf" ] = new eirods::ms_table_entry( "msiExtractTemplateMDFromBuf",3,(funcPtr) msiExtractTemplateMDFromBuf );
			table_[ "msiReadMDTemplateIntoTagStruct" ] = new eirods::ms_table_entry( "msiReadMDTemplateIntoTagStruct",2,(funcPtr) msiReadMDTemplateIntoTagStruct );
			table_[ "msiDataObjPut" ] = new eirods::ms_table_entry( "msiDataObjPut",4,(funcPtr) msiDataObjPut );
			table_[ "msiDataObjGet" ] = new eirods::ms_table_entry( "msiDataObjGet",3,(funcPtr) msiDataObjGet );
			table_[ "msiDataObjChksum" ] = new eirods::ms_table_entry( "msiDataObjChksum",3,(funcPtr) msiDataObjChksum );
			table_[ "msiDataObjPhymv" ] = new eirods::ms_table_entry( "msiDataObjPhymv",6,(funcPtr) msiDataObjPhymv );
			table_[ "msiDataObjRename" ] = new eirods::ms_table_entry( "msiDataObjRename",4,(funcPtr) msiDataObjRename );
			table_[ "msiDataObjTrim" ] = new eirods::ms_table_entry( "msiDataObjTrim",6,(funcPtr) msiDataObjTrim );
			table_[ "msiCollCreate" ] = new eirods::ms_table_entry( "msiCollCreate",3,(funcPtr) msiCollCreate );
			table_[ "msiRmColl" ] = new eirods::ms_table_entry( "msiRmColl",3,(funcPtr) msiRmColl );
			table_[ "msiReplColl" ] = new eirods::ms_table_entry( "msiReplColl",4,(funcPtr) msiReplColl );
			table_[ "msiCollRepl" ] = new eirods::ms_table_entry( "msiCollRepl",3,(funcPtr) msiCollRepl );
			table_[ "msiPhyPathReg" ] = new eirods::ms_table_entry( "msiPhyPathReg",5,(funcPtr) msiPhyPathReg );
			table_[ "msiObjStat" ] = new eirods::ms_table_entry( "msiObjStat",2,(funcPtr) msiObjStat );
			table_[ "msiDataObjRsync" ] = new eirods::ms_table_entry( "msiDataObjRsync",5,(funcPtr) msiDataObjRsync );
			table_[ "msiCollRsync" ] = new eirods::ms_table_entry( "msiCollRsync",5,(funcPtr) msiCollRsync );
			table_[ "msiFreeBuffer" ] = new eirods::ms_table_entry( "msiFreeBuffer",1,(funcPtr) msiFreeBuffer );
			table_[ "msiNoChkFilePathPerm" ] = new eirods::ms_table_entry( "msiNoChkFilePathPerm",0,(funcPtr) msiNoChkFilePathPerm );
			table_[ "msiSetChkFilePathPerm" ] = new eirods::ms_table_entry( "msiSetChkFilePathPerm",1,(funcPtr) msiSetChkFilePathPerm );
			table_[ "msiNoTrashCan" ] = new eirods::ms_table_entry( "msiNoTrashCan",0,(funcPtr) msiNoTrashCan );
			table_[ "msiSetPublicUserOpr" ] = new eirods::ms_table_entry( "msiSetPublicUserOpr",1,(funcPtr) msiSetPublicUserOpr );
			table_[ "delayExec" ] = new eirods::ms_table_entry( "delayExec",3,(funcPtr) delayExec );
			table_[ "remoteExec" ] = new eirods::ms_table_entry( "remoteExec",4,(funcPtr) remoteExec );
			table_[ "msiSleep" ] = new eirods::ms_table_entry( "msiSleep",2,(funcPtr) msiSleep );
			table_[ "writeBytesBuf" ] = new eirods::ms_table_entry( "writeBytesBuf",2,(funcPtr) writeBytesBuf );
			table_[ "writePosInt" ] = new eirods::ms_table_entry( "writePosInt",2,(funcPtr) writePosInt );
			table_[ "writeKeyValPairs" ] = new eirods::ms_table_entry( "writeKeyValPairs",3,(funcPtr) writeKeyValPairs );
			table_[ "msiGetDiffTime" ] = new eirods::ms_table_entry( "msiGetDiffTime", 4, (funcPtr) msiGetDiffTime );
			table_[ "msiGetSystemTime" ] = new eirods::ms_table_entry( "msiGetSystemTime", 2, (funcPtr) msiGetSystemTime );
			table_[ "msiHumanToSystemTime" ] = new eirods::ms_table_entry( "msiHumanToSystemTime", 2, (funcPtr) msiHumanToSystemTime );
            table_[ "msiGetFormattedSystemTime" ] = new eirods::ms_table_entry( "msiGetFormattedSystemTime", 3, (funcPtr) msiGetFormattedSystemTime );
			table_[ "msiStrToBytesBuf" ] = new eirods::ms_table_entry( "msiStrToBytesBuf", 2, (funcPtr) msiStrToBytesBuf );
			table_[ "msiApplyDCMetadataTemplate" ] = new eirods::ms_table_entry( "msiApplyDCMetadataTemplate", 2, (funcPtr) msiApplyDCMetadataTemplate );
			table_[ "msiListEnabledMS" ] = new eirods::ms_table_entry( "msiListEnabledMS", 1, (funcPtr) msiListEnabledMS );
			table_[ "msiServerBackup" ] = new eirods::ms_table_entry( "msiServerBackup", 2, (funcPtr) msiServerBackup );
			table_[ "msiSendStdoutAsEmail" ] = new eirods::ms_table_entry( "msiSendStdoutAsEmail",2,(funcPtr) msiSendStdoutAsEmail );
			table_[ "msiPrintKeyValPair" ] = new eirods::ms_table_entry( "msiPrintKeyValPair",2,(funcPtr) msiPrintKeyValPair );
			table_[ "msiGetValByKey" ] = new eirods::ms_table_entry( "msiGetValByKey",3,(funcPtr) msiGetValByKey );
			table_[ "msiAddKeyVal" ] = new eirods::ms_table_entry( "msiAddKeyVal",3,(funcPtr) msiAddKeyVal );
			table_[ "applyAllRules" ] = new eirods::ms_table_entry( "applyAllRules",3,(funcPtr) msiApplyAllRules );
			table_[ "msiExecStrCondQuery" ] = new eirods::ms_table_entry( "msiExecStrCondQuery",2,(funcPtr) msiExecStrCondQuery );
			table_[ "msiExecStrCondQueryWithOptions" ] = new eirods::ms_table_entry( "msiExecStrCondQueryWithOptions",4,(funcPtr) msiExecStrCondQueryWithOptions );
			table_[ "msiExecGenQuery" ] = new eirods::ms_table_entry( "msiExecGenQuery",2,(funcPtr) msiExecGenQuery );
			table_[ "msiMakeQuery" ] = new eirods::ms_table_entry( "msiMakeQuery",3,(funcPtr) msiMakeQuery );
			table_[ "msiMakeGenQuery" ] = new eirods::ms_table_entry( "msiMakeGenQuery",3,(funcPtr) msiMakeGenQuery );
			table_[ "msiGetMoreRows" ] = new eirods::ms_table_entry( "msiGetMoreRows",3,(funcPtr) msiGetMoreRows );
			table_[ "msiCloseGenQuery" ] = new eirods::ms_table_entry( "msiCloseGenQuery",2,(funcPtr) msiCloseGenQuery );
			table_[ "msiAddSelectFieldToGenQuery" ] = new eirods::ms_table_entry( "msiAddSelectFieldToGenQuery",3,(funcPtr) msiAddSelectFieldToGenQuery );
			table_[ "msiAddConditionToGenQuery" ] = new eirods::ms_table_entry( "msiAddConditionToGenQuery",4,(funcPtr) msiAddConditionToGenQuery );
			table_[ "msiPrintGenQueryOutToBuffer" ] = new eirods::ms_table_entry( "msiPrintGenQueryOutToBuffer",3,(funcPtr) msiPrintGenQueryOutToBuffer );
			table_[ "msiExecCmd" ] = new eirods::ms_table_entry( "msiExecCmd",6,(funcPtr) msiExecCmd );
			table_[ "msiSetGraftPathScheme" ] = new eirods::ms_table_entry( "msiSetGraftPathScheme",2,(funcPtr) msiSetGraftPathScheme );
			table_[ "msiSetRandomScheme" ] = new eirods::ms_table_entry( "msiSetRandomScheme",0,(funcPtr) msiSetRandomScheme );
			table_[ "msiCheckHostAccessControl" ] = new eirods::ms_table_entry( "msiCheckHostAccessControl",0,(funcPtr) msiCheckHostAccessControl );
			table_[ "msiGetIcatTime" ] = new eirods::ms_table_entry( "msiGetIcatTime",2,(funcPtr) msiGetIcatTime );
			table_[ "msiGetTaggedValueFromString" ] = new eirods::ms_table_entry( "msiGetTaggedValueFromString",3,(funcPtr) msiGetTaggedValueFromString );
			table_[ "msiXmsgServerConnect" ] = new eirods::ms_table_entry( "msiXmsgServerConnect",1,(funcPtr) msiXmsgServerConnect );
			table_[ "msiXmsgCreateStream" ] = new eirods::ms_table_entry( "msiXmsgCreateStream",3,(funcPtr) msiXmsgCreateStream );
			table_[ "msiCreateXmsgInp" ] = new eirods::ms_table_entry( "msiCreateXmsgInp",10,(funcPtr) msiCreateXmsgInp );
			table_[ "msiSendXmsg" ] = new eirods::ms_table_entry( "msiSendXmsg",2,(funcPtr) msiSendXmsg );
			table_[ "msiRcvXmsg" ] = new eirods::ms_table_entry( "msiRcvXmsg",6,(funcPtr) msiRcvXmsg );
			table_[ "msiXmsgServerDisConnect" ] = new eirods::ms_table_entry( "msiXmsgServerDisConnect",1,(funcPtr) msiXmsgServerDisConnect );
			table_[ "msiString2KeyValPair" ] = new eirods::ms_table_entry( "msiString2KeyValPair",2,(funcPtr) msiString2KeyValPair );
			table_[ "msiStrArray2String" ] = new eirods::ms_table_entry( "msiStrArray2String",2,(funcPtr) msiStrArray2String );
			table_[ "msiString2StrArray" ] = new eirods::ms_table_entry( "msiString2StrArray",2,(funcPtr) msiString2StrArray );
			table_[ "msiRdaToStdout" ] = new eirods::ms_table_entry( "msiRdaToStdout",6,(funcPtr) msiRdaToStdout );
			table_[ "msiRdaToDataObj" ] = new eirods::ms_table_entry( "msiRdaToDataObj",7,(funcPtr) msiRdaToDataObj );
			table_[ "msiRdaNoResults" ] = new eirods::ms_table_entry( "msiRdaNoResults",6,(funcPtr) msiRdaNoResults );
			table_[ "msiRdaCommit" ] = new eirods::ms_table_entry( "msiRdaCommit",0,(funcPtr) msiRdaCommit );
			table_[ "msiAW1" ] = new eirods::ms_table_entry( "msiAW1",2,(funcPtr) msiAW1 );
			table_[ "msiRdaRollback" ] = new eirods::ms_table_entry( "msiRdaRollback",0,(funcPtr) msiRdaRollback );
			table_[ "msiRenameLocalZone" ] = new eirods::ms_table_entry( "msiRenameLocalZone",2,(funcPtr) msiRenameLocalZone );
			table_[ "msiRenameCollection" ] = new eirods::ms_table_entry( "msiRenameCollection",2,(funcPtr) msiRenameCollection );
			table_[ "msiAclPolicy" ] = new eirods::ms_table_entry( "msiAclPolicy",1,(funcPtr)msiAclPolicy );
			table_[ "msiSetQuota" ] = new eirods::ms_table_entry( "msiSetQuota",4,(funcPtr)msiSetQuota );
			table_[ "msiRemoveKeyValuePairsFromObj" ] = new eirods::ms_table_entry( "msiRemoveKeyValuePairsFromObj",3,(funcPtr) msiRemoveKeyValuePairsFromObj );
			table_[ "msiDataObjPutWithOptions" ] = new eirods::ms_table_entry( "msiDataObjPutWithOptions",6,(funcPtr) msiDataObjPutWithOptions );
			table_[ "msiDataObjReplWithOptions" ] = new eirods::ms_table_entry( "msiDataObjReplWithOptions",4,(funcPtr) msiDataObjReplWithOptions );
			table_[ "msiDataObjChksumWithOptions" ] = new eirods::ms_table_entry( "msiDataObjChksumWithOptions",4,(funcPtr) msiDataObjChksumWithOptions );
			table_[ "msiDataObjGetWithOptions" ] = new eirods::ms_table_entry( "msiDataObjGetWithOptions",4,(funcPtr) msiDataObjGetWithOptions );
			table_[ "msiSetReServerNumProc" ] = new eirods::ms_table_entry( "msiSetReServerNumProc",1,(funcPtr) msiSetReServerNumProc );
			table_[ "msiGetStdoutInExecCmdOut" ] = new eirods::ms_table_entry( "msiGetStdoutInExecCmdOut",2,(funcPtr) msiGetStdoutInExecCmdOut );
			table_[ "msiGetStderrInExecCmdOut" ] = new eirods::ms_table_entry( "msiGetStderrInExecCmdOut",2,(funcPtr) msiGetStderrInExecCmdOut );
			table_[ "msiAddKeyValToMspStr" ] = new eirods::ms_table_entry( "msiAddKeyValToMspStr",3,(funcPtr) msiAddKeyValToMspStr );
			table_[ "msiPrintGenQueryInp" ] = new eirods::ms_table_entry( "msiPrintGenQueryInp",2,(funcPtr) msiPrintGenQueryInp );
			table_[ "msiTarFileExtract" ] = new eirods::ms_table_entry( "msiTarFileExtract",4,(funcPtr) msiTarFileExtract );
			table_[ "msiTarFileCreate" ] = new eirods::ms_table_entry( "msiTarFileCreate",4,(funcPtr) msiTarFileCreate );
			table_[ "msiPhyBundleColl" ] = new eirods::ms_table_entry( "msiPhyBundleColl",3,(funcPtr) msiPhyBundleColl );
			table_[ "msiWriteRodsLog" ] = new eirods::ms_table_entry( "msiWriteRodsLog",2,(funcPtr) msiWriteRodsLog );
			table_[ "msiServerMonPerf" ] = new eirods::ms_table_entry( "msiServerMonPerf",2,(funcPtr) msiServerMonPerf );
			table_[ "msiFlushMonStat" ] = new eirods::ms_table_entry( "msiFlushMonStat",2,(funcPtr) msiFlushMonStat );
			table_[ "msiDigestMonStat" ] = new eirods::ms_table_entry( "msiDigestMonStat",7,(funcPtr) msiDigestMonStat );
			table_[ "msiSplitPath" ] = new eirods::ms_table_entry( "msiSplitPath",3,(funcPtr) msiSplitPath );
			table_[ "msiGetSessionVarValue" ] = new eirods::ms_table_entry( "msiGetSessionVarValue",2,(funcPtr) msiGetSessionVarValue );
			table_[ "msiAutoReplicateService" ] = new eirods::ms_table_entry( "msiAutoReplicateService", 5, (funcPtr)msiAutoReplicateService );
			table_[ "msiDataObjAutoMove" ] = new eirods::ms_table_entry( "msiDataObjAutoMove", 5, (funcPtr)msiDataObjAutoMove );
			table_[ "msiGetContInxFromGenQueryOut" ] = new eirods::ms_table_entry( "msiGetContInxFromGenQueryOut",2,(funcPtr) msiGetContInxFromGenQueryOut );
			table_[ "msiSetACL" ] = new eirods::ms_table_entry( "msiSetACL",4,(funcPtr) msiSetACL );
			table_[ "msiSetRescQuotaPolicy" ] = new eirods::ms_table_entry( "msiSetRescQuotaPolicy",1,(funcPtr) msiSetRescQuotaPolicy );
			table_[ "msiAdmReadDVMapsFromFileIntoStruct" ] = new eirods::ms_table_entry( "msiAdmReadDVMapsFromFileIntoStruct",2, (funcPtr) msiAdmReadDVMapsFromFileIntoStruct );
			table_[ "msiAdmInsertDVMapsFromStructIntoDB" ] = new eirods::ms_table_entry( "msiAdmInsertDVMapsFromStructIntoDB",2, (funcPtr) msiAdmInsertDVMapsFromStructIntoDB );
			table_[ "msiGetDVMapsFromDBIntoStruct" ] = new eirods::ms_table_entry( "msiGetDVMapsFromDBIntoStruct",3, (funcPtr) msiGetDVMapsFromDBIntoStruct );
			table_[ "msiAdmWriteDVMapsFromStructIntoFile" ] = new eirods::ms_table_entry( "msiAdmWriteDVMapsFromStructIntoFile",2, (funcPtr) msiAdmWriteDVMapsFromStructIntoFile );
			table_[ "msiAdmReadFNMapsFromFileIntoStruct" ] = new eirods::ms_table_entry( "msiAdmReadFNMapsFromFileIntoStruct",2, (funcPtr) msiAdmReadFNMapsFromFileIntoStruct );
			table_[ "msiAdmInsertFNMapsFromStructIntoDB" ] = new eirods::ms_table_entry( "msiAdmInsertFNMapsFromStructIntoDB",2, (funcPtr) msiAdmInsertFNMapsFromStructIntoDB );
			table_[ "msiGetFNMapsFromDBIntoStruct" ] = new eirods::ms_table_entry( "msiGetFNMapsFromDBIntoStruct",3, (funcPtr) msiGetFNMapsFromDBIntoStruct );
			table_[ "msiAdmWriteFNMapsFromStructIntoFile" ] = new eirods::ms_table_entry( "msiAdmWriteFNMapsFromStructIntoFile",2, (funcPtr) msiAdmWriteFNMapsFromStructIntoFile );
			table_[ "msiAdmWriteMSrvcsFromStructIntoFilemsiAdmReadMSrvcsFromFileIntoStruct" ] = new eirods::ms_table_entry( "msiAdmReadMSrvcsFromFileIntoStruct",2, (funcPtr) msiAdmReadMSrvcsFromFileIntoStruct );
			table_[ "msiAdmInsertMSrvcsFromStructIntoDB" ] = new eirods::ms_table_entry( "msiAdmInsertMSrvcsFromStructIntoDB",1, (funcPtr) msiAdmInsertMSrvcsFromStructIntoDB );
			table_[ "msiGetMSrvcsFromDBIntoStruct" ] = new eirods::ms_table_entry( "msiGetMSrvcsFromDBIntoStruct",2, (funcPtr) msiGetMSrvcsFromDBIntoStruct );
			table_[ "msiAdmWriteMSrvcsFromStructIntoFile" ] = new eirods::ms_table_entry( "msiAdmWriteMSrvcsFromStructIntoFile",2, (funcPtr) msiAdmWriteMSrvcsFromStructIntoFile );
			table_[ "writeXMsg" ] = new eirods::ms_table_entry( "writeXMsg",3, (funcPtr) writeXMsg );
			table_[ "readXMsg" ] = new eirods::ms_table_entry( "readXMsg",8, (funcPtr) readXMsg );
			table_[ "msiSetReplComment" ] = new eirods::ms_table_entry( "msiSetReplComment", 4, (funcPtr) msiSetReplComment );
			table_[ "msiSetBulkPutPostProcPolicy" ] = new eirods::ms_table_entry( "msiSetBulkPutPostProcPolicy",1,(funcPtr) msiSetBulkPutPostProcPolicy );
			table_[ "msiStrlen" ] = new eirods::ms_table_entry( "msiStrlen",2,(funcPtr) msiStrlen );
			table_[ "msiStrchop" ] = new eirods::ms_table_entry( "msiStrchop",2,(funcPtr) msiStrchop );
			table_[ "msiSubstr" ] = new eirods::ms_table_entry( "msiSubstr",4,(funcPtr) msiSubstr );
			table_[ "msiCutBufferInHalf" ] = new eirods::ms_table_entry( "msiCutBufferInHalf",1,(funcPtr) msiCutBufferInHalf );
			table_[ "msiDoSomething" ] = new eirods::ms_table_entry( "msiDoSomething", 2, (funcPtr) msiDoSomething );  
			table_[ "msiExit" ] = new eirods::ms_table_entry( "msiExit",2,(funcPtr) msiExit );
			table_[ "msiSysMetaModify" ] = new eirods::ms_table_entry( "msiSysMetaModify",2,(funcPtr) msiSysMetaModify );
#else

microsdef_t MicrosTable[] = {
  {"print_hello", 0, (funcPtr) print_hello},
  {"print_hello_arg", 1, (funcPtr) print_hello_arg},
  {"msiVacuum", 0, (funcPtr) msiVacuum},
  {"msiQuota", 0, (funcPtr) msiQuota},
  {"msiDeleteUnusedAVUs", 0, (funcPtr) msiDeleteUnusedAVUs},
  {"msiGoodFailure", 0, (funcPtr) msiGoodFailure},
  {"msiSetResource", 1,(funcPtr)  msiSetResource},
  {"msiCheckPermission", 1,(funcPtr)  msiCheckPermission},
  {"msiCheckAccess", 3,(funcPtr)  msiCheckAccess},
  {"msiCheckOwner", 0, (funcPtr) msiCheckOwner},
  {"msiCreateUser", 0, (funcPtr) msiCreateUser},
  {"msiCreateCollByAdmin",2, (funcPtr) msiCreateCollByAdmin},
  {"msiSendMail",3, (funcPtr) msiSendMail},
  {"recover_print_hello", 0, (funcPtr) recover_print_hello},
  {"msiCommit", 0, (funcPtr) msiCommit},
  {"msiRollback", 0, (funcPtr) msiRollback},
  {"msiDeleteCollByAdmin",2, (funcPtr) msiDeleteCollByAdmin},
  {"msiDeleteUser", 0, (funcPtr) msiDeleteUser},
  {"msiAddUserToGroup", 1, (funcPtr) msiAddUserToGroup},
  {"msiSetDefaultResc", 2, (funcPtr) msiSetDefaultResc},
  {"msiSetRescSortScheme", 1, (funcPtr) msiSetRescSortScheme},
  {"msiSysReplDataObj", 2, (funcPtr) msiSysReplDataObj},
  {"msiStageDataObj", 1, (funcPtr) msiStageDataObj},
  {"msiSetDataObjPreferredResc", 1, (funcPtr) msiSetDataObjPreferredResc},
  {"msiSetDataObjAvoidResc", 1, (funcPtr) msiSetDataObjAvoidResc},
  {"msiSortDataObj", 1, (funcPtr) msiSortDataObj},
  {"msiSysChksumDataObj", 0, (funcPtr) msiSysChksumDataObj},
  {"msiSetDataTypeFromExt", 0, (funcPtr) msiSetDataTypeFromExt},
  {"msiSetNoDirectRescInp",1,(funcPtr) msiSetNoDirectRescInp},
  {"msiSetNumThreads", 3,(funcPtr) msiSetNumThreads},
  {"msiDeleteDisallowed",0,(funcPtr) msiDeleteDisallowed},
  {"msiOprDisallowed",0,(funcPtr) msiOprDisallowed},
  {"msiDataObjCreate",3,(funcPtr) msiDataObjCreate},
  {"msiDataObjOpen",2,(funcPtr) msiDataObjOpen},
  {"msiDataObjClose",2,(funcPtr) msiDataObjClose},
  {"msiDataObjLseek",4,(funcPtr) msiDataObjLseek},
  {"msiDataObjRead",3,(funcPtr) msiDataObjRead},
  {"msiDataObjWrite",3,(funcPtr) msiDataObjWrite},
  {"msiDataObjUnlink",2,(funcPtr) msiDataObjUnlink},
  {"msiDataObjRepl",3,(funcPtr) msiDataObjRepl},
  {"msiDataObjCopy",4,(funcPtr) msiDataObjCopy},
  {"msiExtractNaraMetadata",0,(funcPtr) msiExtractNaraMetadata},
  {"msiSetMultiReplPerResc",0,(funcPtr) msiSetMultiReplPerResc},
  {"msiAdmChangeCoreIRB",1,(funcPtr) msiAdmChangeCoreIRB},
  //{"msiAdmShowIRB",1,(funcPtr) msiAdmShowIRB},
  {"msiAdmShowDVM",1,(funcPtr) msiAdmShowDVM},
  {"msiAdmShowFNM",1,(funcPtr) msiAdmShowFNM},
  {"msiAdmAppendToTopOfCoreIRB",1,(funcPtr) msiAdmAppendToTopOfCoreIRB},
  {"msiGetObjType",2,(funcPtr) msiGetObjType},
  {"msiAssociateKeyValuePairsToObj",3,(funcPtr) msiAssociateKeyValuePairsToObj},
{"msiSetKeyValuePairsToObj",3,(funcPtr) msiSetKeyValuePairsToObj},
  {"msiExtractTemplateMDFromBuf",3,(funcPtr) msiExtractTemplateMDFromBuf},
  {"msiReadMDTemplateIntoTagStruct",2,(funcPtr) msiReadMDTemplateIntoTagStruct},
  {"msiDataObjPut",4,(funcPtr) msiDataObjPut},
  {"msiDataObjGet",3,(funcPtr) msiDataObjGet},
  {"msiDataObjChksum",3,(funcPtr) msiDataObjChksum},
  {"msiDataObjPhymv",6,(funcPtr) msiDataObjPhymv},
  {"msiDataObjRename",4,(funcPtr) msiDataObjRename},
  {"msiDataObjTrim",6,(funcPtr) msiDataObjTrim},
  {"msiCollCreate",3,(funcPtr) msiCollCreate},
  {"msiRmColl",3,(funcPtr) msiRmColl},
  {"msiReplColl",4,(funcPtr) msiReplColl},
  {"msiCollRepl",3,(funcPtr) msiCollRepl},
  {"msiPhyPathReg",5,(funcPtr) msiPhyPathReg},
  {"msiObjStat",2,(funcPtr) msiObjStat},
  {"msiDataObjRsync",5,(funcPtr) msiDataObjRsync},
  {"msiCollRsync",5,(funcPtr) msiCollRsync},
  {"msiFreeBuffer",1,(funcPtr) msiFreeBuffer},
  {"msiNoChkFilePathPerm",0,(funcPtr) msiNoChkFilePathPerm},
  {"msiSetChkFilePathPerm",1,(funcPtr) msiSetChkFilePathPerm},
  {"msiNoTrashCan",0,(funcPtr) msiNoTrashCan},
  {"msiSetPublicUserOpr",1,(funcPtr) msiSetPublicUserOpr},
  {"delayExec",3,(funcPtr) delayExec},
  {"remoteExec",4,(funcPtr) remoteExec},
  {"msiSleep",2,(funcPtr) msiSleep},
  {"writeBytesBuf",2,(funcPtr) writeBytesBuf},
  {"writePosInt",2,(funcPtr) writePosInt},
  {"writeKeyValPairs",3,(funcPtr) writeKeyValPairs},
  {"msiGetDiffTime", 4, (funcPtr) msiGetDiffTime},
  {"msiGetSystemTime", 2, (funcPtr) msiGetSystemTime},
  {"msiGetFormattedSystemTime", 3, (funcPtr) msiGetFormattedSystemTime},
  {"msiHumanToSystemTime", 2, (funcPtr) msiHumanToSystemTime},
  {"msiStrToBytesBuf", 2, (funcPtr) msiStrToBytesBuf},
  {"msiBytesBufToStr", 2, (funcPtr) msiBytesBufToStr},
  {"msiApplyDCMetadataTemplate", 2, (funcPtr) msiApplyDCMetadataTemplate},
  {"msiListEnabledMS", 1, (funcPtr) msiListEnabledMS},
  {"msiServerBackup", 2, (funcPtr) msiServerBackup},
  {"msiSendStdoutAsEmail",2,(funcPtr) msiSendStdoutAsEmail},
  {"msiPrintKeyValPair",2,(funcPtr) msiPrintKeyValPair},
  {"msiGetValByKey",3,(funcPtr) msiGetValByKey},
  {"msiAddKeyVal",3,(funcPtr) msiAddKeyVal},
  {"applyAllRules",3,(funcPtr) msiApplyAllRules},
  {"msiExecStrCondQuery",2,(funcPtr) msiExecStrCondQuery},
  {"msiExecStrCondQueryWithOptionsNew",4,(funcPtr) msiExecStrCondQueryWithOptionsNew},
  {"msiExecStrCondQueryWithOptions",4,(funcPtr) msiExecStrCondQueryWithOptions},  
  {"msiExecGenQuery",2,(funcPtr) msiExecGenQuery},
  {"msiMakeQuery",3,(funcPtr) msiMakeQuery},
  {"msiMakeGenQuery",3,(funcPtr) msiMakeGenQuery},
  {"msiGetMoreRows",3,(funcPtr) msiGetMoreRows},
  {"msiCloseGenQuery",2,(funcPtr) msiCloseGenQuery},
  {"msiAddSelectFieldToGenQuery",3,(funcPtr) msiAddSelectFieldToGenQuery},
  {"msiAddConditionToGenQuery",4,(funcPtr) msiAddConditionToGenQuery},
  {"msiPrintGenQueryOutToBuffer",3,(funcPtr) msiPrintGenQueryOutToBuffer},
  {"msiExecCmd",6,(funcPtr) msiExecCmd},
  {"msiSetGraftPathScheme",2,(funcPtr) msiSetGraftPathScheme},
  {"msiSetRandomScheme",0,(funcPtr) msiSetRandomScheme},
  {"msiCheckHostAccessControl",0,(funcPtr) msiCheckHostAccessControl},
  {"msiGetIcatTime",2,(funcPtr) msiGetIcatTime},
  {"msiGetTaggedValueFromString",3,(funcPtr) msiGetTaggedValueFromString},
  {"msiXmsgServerConnect",1,(funcPtr) msiXmsgServerConnect},
  {"msiXmsgCreateStream",3,(funcPtr) msiXmsgCreateStream},
  {"msiCreateXmsgInp",10,(funcPtr) msiCreateXmsgInp},
  {"msiSendXmsg",2,(funcPtr) msiSendXmsg},
  {"msiRcvXmsg",6,(funcPtr) msiRcvXmsg},
  {"msiXmsgServerDisConnect",1,(funcPtr) msiXmsgServerDisConnect},
  {"msiString2KeyValPair",2,(funcPtr) msiString2KeyValPair},
  {"msiStrArray2String",2,(funcPtr) msiStrArray2String},
  {"msiString2StrArray",2,(funcPtr) msiString2StrArray},
  {"msiRdaToStdout",6,(funcPtr) msiRdaToStdout},
  {"msiRdaToDataObj",7,(funcPtr) msiRdaToDataObj},
  {"msiRdaNoResults",6,(funcPtr) msiRdaNoResults},
  {"msiRdaCommit",0,(funcPtr) msiRdaCommit},
  {"msiAW1",2,(funcPtr) msiAW1},
  {"msiRdaRollback",0,(funcPtr) msiRdaRollback},
  {"msiRenameLocalZone",2,(funcPtr) msiRenameLocalZone},
  {"msiRenameCollection",2,(funcPtr) msiRenameCollection},
  {"msiAclPolicy",1,(funcPtr)msiAclPolicy},
  {"msiSetQuota",4,(funcPtr)msiSetQuota},
  {"msiRemoveKeyValuePairsFromObj",3,(funcPtr) msiRemoveKeyValuePairsFromObj},
  {"msiDataObjPutWithOptions",6,(funcPtr) msiDataObjPutWithOptions},
  {"msiDataObjReplWithOptions",4,(funcPtr) msiDataObjReplWithOptions},
  {"msiDataObjChksumWithOptions",4,(funcPtr) msiDataObjChksumWithOptions},
  {"msiDataObjGetWithOptions",4,(funcPtr) msiDataObjGetWithOptions},
  {"msiSetReServerNumProc",1,(funcPtr) msiSetReServerNumProc},
  {"msiGetStdoutInExecCmdOut",2,(funcPtr) msiGetStdoutInExecCmdOut},
  {"msiGetStderrInExecCmdOut",2,(funcPtr) msiGetStderrInExecCmdOut},
  {"msiAddKeyValToMspStr",3,(funcPtr) msiAddKeyValToMspStr},
  {"msiPrintGenQueryInp",2,(funcPtr) msiPrintGenQueryInp},
  {"msiTarFileExtract",4,(funcPtr) msiTarFileExtract},
  {"msiTarFileCreate",4,(funcPtr) msiTarFileCreate},
  {"msiPhyBundleColl",3,(funcPtr) msiPhyBundleColl},
  {"msiWriteRodsLog",2,(funcPtr) msiWriteRodsLog},
  {"msiServerMonPerf",2,(funcPtr) msiServerMonPerf},
  {"msiFlushMonStat",2,(funcPtr) msiFlushMonStat},
  {"msiDigestMonStat",7,(funcPtr) msiDigestMonStat},
  {"msiSplitPath",3,(funcPtr) msiSplitPath},
  {"msiSplitPathByKey",4,(funcPtr) msiSplitPathByKey},
  {"msiGetSessionVarValue",2,(funcPtr) msiGetSessionVarValue},
  {"msiAutoReplicateService", 5, (funcPtr)msiAutoReplicateService},
  {"msiDataObjAutoMove", 5, (funcPtr)msiDataObjAutoMove},
  {"msiGetContInxFromGenQueryOut",2,(funcPtr) msiGetContInxFromGenQueryOut},
  {"msiSetACL",4,(funcPtr) msiSetACL},
  {"msiSetRescQuotaPolicy",1,(funcPtr) msiSetRescQuotaPolicy},
  {"msiAdmReadDVMapsFromFileIntoStruct",2, (funcPtr) msiAdmReadDVMapsFromFileIntoStruct},
  {"msiAdmInsertDVMapsFromStructIntoDB",2, (funcPtr) msiAdmInsertDVMapsFromStructIntoDB},
  {"msiGetDVMapsFromDBIntoStruct",3, (funcPtr) msiGetDVMapsFromDBIntoStruct},
  {"msiAdmWriteDVMapsFromStructIntoFile",2, (funcPtr) msiAdmWriteDVMapsFromStructIntoFile},
  {"msiAdmReadFNMapsFromFileIntoStruct",2, (funcPtr) msiAdmReadFNMapsFromFileIntoStruct},
  {"msiAdmInsertFNMapsFromStructIntoDB",2, (funcPtr) msiAdmInsertFNMapsFromStructIntoDB},
  {"msiGetFNMapsFromDBIntoStruct",3, (funcPtr) msiGetFNMapsFromDBIntoStruct},
  {"msiAdmWriteFNMapsFromStructIntoFile",2, (funcPtr) msiAdmWriteFNMapsFromStructIntoFile},
  {"msiAdmReadMSrvcsFromFileIntoStruct",2, (funcPtr) msiAdmReadMSrvcsFromFileIntoStruct},
  {"msiAdmInsertMSrvcsFromStructIntoDB",1, (funcPtr) msiAdmInsertMSrvcsFromStructIntoDB},
  {"msiGetMSrvcsFromDBIntoStruct",2, (funcPtr) msiGetMSrvcsFromDBIntoStruct},
  {"msiAdmWriteMSrvcsFromStructIntoFile",2, (funcPtr) msiAdmWriteMSrvcsFromStructIntoFile},
  {"writeXMsg",3, (funcPtr) writeXMsg},
  {"readXMsg",8, (funcPtr) readXMsg},
  {"msiSetReplComment", 4, (funcPtr) msiSetReplComment},
  {"msiSetBulkPutPostProcPolicy",1,(funcPtr) msiSetBulkPutPostProcPolicy},
  {"msiStrlen",2,(funcPtr) msiStrlen},
  {"msiStrchop",2,(funcPtr) msiStrchop},
  {"msiSubstr",4,(funcPtr) msiSubstr},
  {"msiCutBufferInHalf",1,(funcPtr) msiCutBufferInHalf},
  {"msiDoSomething", 2, (funcPtr) msiDoSomething},  
  {"msiDbrCommit", 1, (funcPtr) msiDbrCommit},
  {"msiDbrRollback", 1, (funcPtr) msiDbrRollback},
  {"msiDboExec",10,(funcPtr) msiDboExec},
  {"msiExit",2,(funcPtr) msiExit},
  {"msiStrCat",2,(funcPtr) msiStrCat},
  {"msiSysMetaModify",2,(funcPtr) msiSysMetaModify},
#ifdef NETCDF_API
  {"msiNcOpen",3,(funcPtr) msiNcOpen},
  {"msiNcCreate",3,(funcPtr) msiNcCreate},
  {"msiNcClose",1,(funcPtr) msiNcClose},
  {"msiNcInqId",4,(funcPtr) msiNcInqId},
  {"msiNcInqWithId",4,(funcPtr) msiNcInqWithId},
  {"msiNcGetVarsByType",8,(funcPtr) msiNcGetVarsByType},
  {"msiNcGetArrayLen",2,(funcPtr) msiNcGetArrayLen},
  {"msiNcGetNumDim",2,(funcPtr) msiNcGetNumDim},
  {"msiNcGetDataType",2,(funcPtr) msiNcGetDataType},
  {"msiNcGetElementInArray",3,(funcPtr) msiNcGetElementInArray},
  {"msiFloatToString",2,(funcPtr) msiFloatToString},
  {"msiNcInq",2,(funcPtr) msiNcInq},
  {"msiNcGetNdimsInInqOut",3,(funcPtr) msiNcGetNdimsInInqOut},
  {"msiNcGetNattsInInqOut",3,(funcPtr) msiNcGetNattsInInqOut},
  {"msiNcGetNvarsInInqOut",2,(funcPtr) msiNcGetNvarsInInqOut},
  {"msiNcGetFormatInInqOut",2,(funcPtr) msiNcGetFormatInInqOut},
  {"msiNcGetVarNameInInqOut",3,(funcPtr) msiNcGetVarNameInInqOut},
  {"msiNcGetDimNameInInqOut",4,(funcPtr) msiNcGetDimNameInInqOut},
  {"msiNcGetAttNameInInqOut",4,(funcPtr) msiNcGetAttNameInInqOut},
  {"msiNcGetVarTypeInInqOut",3,(funcPtr) msiNcGetVarTypeInInqOut},
  {"msiNcIntDataTypeToStr",2,(funcPtr) msiNcIntDataTypeToStr},
  {"msiNcGetAttValStrInInqOut",4,(funcPtr) msiNcGetAttValStrInInqOut},
  {"msiAddToNcArray",3,(funcPtr) msiAddToNcArray},
  {"msiNcGetDimLenInInqOut",4,(funcPtr) msiNcGetDimLenInInqOut},
  {"msiNcGetVarIdInInqOut",3,(funcPtr) msiNcGetVarIdInInqOut},
  {"msiFreeNcStruct",1,(funcPtr) msiFreeNcStruct},
#ifdef NETCDF4_API
  {"msiNcOpenGroup",3,(funcPtr) msiNcOpenGroup},
  {"msiNcInqGrps",2,(funcPtr) msiNcInqGrps},
#endif
  {"msiNcGetNGrpsInInqOut",2,(funcPtr) msiNcGetNGrpsInInqOut},
  {"msiNcGetGrpInInqOut",3,(funcPtr) msiNcGetGrpInInqOut},
  {"msiNcRegGlobalAttr",3,(funcPtr) msiNcRegGlobalAttr},
  {"msiNcSubsetVar",5,(funcPtr) msiNcSubsetVar},
  {"msiNcVarStat",2,(funcPtr) msiNcVarStat},
#ifdef LIB_CF
  {"msiNccfGetVara",10,(funcPtr) msiNccfGetVara},
#endif
#endif
#endif

#ifdef USE_EIRODS
	}; // ms_table::ms_table

    // =-=-=-=-=-=-=-
    // implement the micros table dtor 
    template<>
    lookup_table< eirods::ms_table_entry* >::~lookup_table() {
        ms_table::iterator itr = begin();
        for( ; itr != end(); ++itr ) {
            delete itr->second;
        }
    }

}; // namespace eirods

int NumOfAction = -1; // no longer used

eirods::ms_table MicrosTable;

#else
};
int NumOfAction = sizeof(MicrosTable) / sizeof(microsdef_t);
#endif

#endif	/* RE_ACTION_H */

